#include<stdlib.h>
#include<stdio.h>
#include "macierz.h"

/* Funkcja tworzy macierz o podanej liczbie wierszy 'w' i kolumn 'k'.
 * Wartoscia zwracana jest sreuktura macierz zawierajaca liczbe wierszy i kolumn oraz adres (wskaznik) do tablicy o dlugosci 'w' zawierajacej adresy do tablic o dlugosci 'k' zawierajacych liczby rzeczywiste. */
struct macierz utworz_macierz(int w, int k)
{
	struct macierz m;
	int i=0;
	m.wsp=(float **)malloc(w * sizeof(float *));
	if (m.wsp==NULL) 
   {
      m.w=0;
      m.k=0;
      return m;
   }
   
   m.w=w;
   m.k=k;
	for (i=0;i<w;i++)
		*(m.wsp+i)=(float *)malloc(k * sizeof(float));
	
   return m;
}

/* Funkcja wyswietla macierz 'm'.  */
void wyswietl_macierz(struct macierz m)
{
	int i,j;
	printf("\nMacierz %dx%d\n",m.w,m.k);
	for(i=0;i<m.w;i++)
 	{
  		for(j=0;j<m.k;j++)	printf("%6.2f ",*(*(m.wsp+i)+j));
 		printf("\n");
	}
}

/* Funkcja zwalnia pamiec zajeta przez macierz 'm'. */
void zwolnij_macierz(struct macierz m)
{
   int w=m.w;
	while(w-- > 0) free(*(m.wsp+w));
	free(m.wsp);
}

/* Funkcja wczytuje wartosci macierzy z ekranu.    */
void wczytaj_macierz(struct macierz m)
{
	int i,j;
 	printf("Podaj elementy macierzy %dx%d\n",m.w,m.k);
 	for(i=0;i<m.w;i++)
 	{
  		for(j=0;j<m.k;j++)
  		{
   		printf("[%d,%d] = ",i,j);
   		scanf("%f",*(m.wsp+i)+j);
  		}
 	}
}

